# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2024"
rust-version = "1.94.1"
name = "geiserx_ts_runtime"
version = "0.24.0"
build = false
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "tailscale runtime"
readme = "README.md"
keywords = [
    "tailscale",
    "runtime",
]
categories = ["network-programming"]
license = "BSD-3-Clause"
repository = "https://github.com/GeiserX/tailscale-rs"

[features]
acme = ["ts_control/acme"]
tun = [
    "dep:ts_transport_tun",
    "dep:ts_host_net",
    "dep:etherparse",
]

[lib]
name = "ts_runtime"
path = "src/lib.rs"

[dependencies.base64]
version = "0.22"

[dependencies.chrono]
version = "0.4"
default-features = false

[dependencies.etherparse]
version = "0.19"
optional = true

[dependencies.futures]
version = "0.3"
default-features = false

[dependencies.httparse]
version = "1"

[dependencies.ipnet]
version = "2.12"
default-features = false

[dependencies.kameo]
version = "0.19"

[dependencies.kameo_actors]
version = "0.4"

[dependencies.smallvec]
version = "1.15"

[dependencies.thiserror]
version = "2"
default-features = false

[dependencies.tokio]
version = "1"
features = [
    "rt-multi-thread",
    "macros",
    "net",
    "time",
    "io-util",
    "sync",
]
default-features = false

[dependencies.tracing]
version = "0.1"
features = ["attributes"]
default-features = false

[dependencies.ts_bart]
version = "0.24.0"
package = "geiserx_ts_bart"

[dependencies.ts_bart_packetfilter]
version = "0.24.0"
package = "geiserx_ts_bart_packetfilter"

[dependencies.ts_control]
version = "0.24.0"
package = "geiserx_ts_control"

[dependencies.ts_dataplane]
version = "0.24.0"
package = "geiserx_ts_dataplane"

[dependencies.ts_derp]
version = "0.24.0"
package = "geiserx_ts_derp"

[dependencies.ts_dns_wire]
version = "0.24.0"
package = "geiserx_ts_dns_wire"

[dependencies.ts_forwarder]
version = "0.24.0"
package = "geiserx_ts_forwarder"

[dependencies.ts_host_net]
version = "0.24.0"
optional = true
package = "geiserx_ts_host_net"

[dependencies.ts_keys]
version = "0.24.0"
package = "geiserx_ts_keys"

[dependencies.ts_magicsock]
version = "0.24.0"
package = "geiserx_ts_magicsock"

[dependencies.ts_netcheck]
version = "0.24.0"
package = "geiserx_ts_netcheck"

[dependencies.ts_netstack_smoltcp]
version = "0.24.0"
features = ["tokio"]
package = "geiserx_ts_netstack_smoltcp"

[dependencies.ts_overlay_router]
version = "0.24.0"
package = "geiserx_ts_overlay_router"

[dependencies.ts_packet]
version = "0.24.0"
package = "geiserx_ts_packet"

[dependencies.ts_packetfilter]
version = "0.24.0"
features = ["checking-filter"]
package = "geiserx_ts_packetfilter"

[dependencies.ts_packetfilter_state]
version = "0.24.0"
package = "geiserx_ts_packetfilter_state"

[dependencies.ts_tka]
version = "0.24.0"
package = "geiserx_ts_tka"

[dependencies.ts_transport]
version = "0.24.0"
package = "geiserx_ts_transport"

[dependencies.ts_transport_tun]
version = "0.24.0"
optional = true
package = "geiserx_ts_transport_tun"

[dependencies.ts_tunnel]
version = "0.24.0"
package = "geiserx_ts_tunnel"

[dependencies.url]
version = "2"
default-features = false

[dev-dependencies.ed25519-dalek]
version = "2"

[dev-dependencies.itertools]
version = "0.14"

[dev-dependencies.proptest]
version = "1.11"

[dev-dependencies.rand]
version = "0.10"

[lints.clippy]
multiple_crate_versions = "allow"
too_many_arguments = "allow"

[lints.clippy.cargo]
level = "warn"
priority = -1

[lints.rust]
closure_returning_async_block = "warn"
let-underscore = "warn"
missing_docs = "warn"

[lints.rustdoc]
bare_urls = "deny"
broken_intra_doc_links = "deny"
invalid_html_tags = "deny"
private_intra_doc_links = "deny"
